<?php
/********************************************************************
 iGalerie - script de galerie d'images
 Copyright (C) 2006-2013 - http://www.igalerie.org/

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
********************************************************************/

error_reporting(0);
ob_start('ob_gzhandler');

// On annule la fonction magic_quotes_gpc.
function strip_magic_quotes(&$valeur) {
	$valeur = stripslashes($valeur);
}
if (get_magic_quotes_gpc()) {
	array_walk($_GET, 'strip_magic_quotes');
}

// On supprime tout paramtre non existant.
foreach ($_GET as $name => $value) {
	$R = array();
	if (!in_array($name, $R)) {
		unset($_GET[$name]);
	}
}
foreach ($_POST as $name => $value) {
	$R = array('upgrade');
	if (!in_array($name, $R)) {
		unset($_POST[$name]);
	}
}
foreach ($_COOKIE as $name => $value) {
	$R = array();
	if (!in_array($name, $R)) {
		unset($_COOKIE[$name]);
	}
}

// Chargement de la config.
if (file_exists(dirname(__FILE__) . '/config/conf.php')) {
	require_once(dirname(__FILE__) . '/config/conf.php');
} else {
	define('GALERIE_INSTALL', 0);
}

// La galerie est-elle installe ?
if (!defined('GALERIE_INSTALL') || !GALERIE_INSTALL) {
	header('Location:install/');
	exit;
}

// La galerie est-elle dj  jour ?
if (defined('GALERIE_VERSION') && GALERIE_VERSION == '20130107') {
	die('La galerie est  jour.');
}

// Mise  jour.
$error_code = '';
if (isset($_POST['upgrade'])) {

	require_once(dirname(__FILE__) . '/includes/classes/class.files.php');
	require_once(dirname(__FILE__) . '/includes/classes/class.mysql.php');
	require_once(dirname(__FILE__) . '/includes/classes/class.outils.php');

	$maj_ok = 1;


	/* ---------- FONCTIONS DE MISE A JOUR ---------- */

	/* 
	  *	Mise  jour du fichier de configuration.
	*/
	function upgrade_conf($conf) {
		if ($id = @fopen('config/conf.php', 'w')) {
			$config = "<?php\n\n";
			$config .= "define('ADMIN_USER', '" . $conf['ADMIN_USER'] . "');\n";
			$config .= "define('ADMIN_PASS', '" . $conf['ADMIN_PASS'] . "');\n";
			$config .= "define('MYSQL_SERV', '" . $conf['MYSQL_SERV'] . "');\n";
			$config .= "define('MYSQL_USER', '" . $conf['MYSQL_USER'] . "');\n";
			$config .= "define('MYSQL_PASS', '" . $conf['MYSQL_PASS'] . "');\n";
			$config .= "define('MYSQL_BASE', '" . $conf['MYSQL_BASE'] . "');\n";
			$config .= "define('MYSQL_PREF', '" . $conf['MYSQL_PREF'] . "');\n";
			$config .= "define('THUMB_TDIR', '" . $conf['THUMB_TDIR'] . "');\n";
			$config .= "define('THUMB_PREF', '" . $conf['THUMB_PREF'] . "');\n";
			$config .= "define('THUMB_ALB_MODE', '" . $conf['THUMB_ALB_MODE'] . "');\n";
			$config .= "define('THUMB_ALB_SIZE', " . $conf['THUMB_ALB_SIZE'] . ");\n";
			$config .= "define('THUMB_ALB_CROP_WIDTH', " . $conf['THUMB_ALB_CROP_WIDTH'] . ");\n";
			$config .= "define('THUMB_ALB_CROP_HEIGHT', " . $conf['THUMB_ALB_CROP_HEIGHT'] . ");\n";
			$config .= "define('THUMB_IMG_MODE', '" . $conf['THUMB_IMG_MODE'] . "');\n";
			$config .= "define('THUMB_IMG_SIZE', " . $conf['THUMB_IMG_SIZE'] . ");\n";
			$config .= "define('THUMB_IMG_CROP_WIDTH', " . $conf['THUMB_IMG_CROP_WIDTH'] . ");\n";
			$config .= "define('THUMB_IMG_CROP_HEIGHT', " . $conf['THUMB_IMG_CROP_HEIGHT'] . ");\n";
			$config .= "define('THUMB_QUALITY', 80);\n";
			$config .= "define('IMG_RESIZE_GD', '" . $conf['IMG_RESIZE_GD'] . "');\n";
			$config .= "define('IMG_TEXTE', '" . $conf['IMG_TEXTE'] . "');\n";
			$config .= "define('IMG_TEXTE_PARAMS', '" . $conf['IMG_TEXTE_PARAMS'] . "');\n";
			$config .= "define('GALERIE_URL', '" . $conf['GALERIE_URL'] . "');\n";
			$config .= "define('GALERIE_PATH', '" . $conf['GALERIE_PATH'] . "');\n";
			$config .= "define('GALERIE_THEME', '" . $conf['GALERIE_THEME'] . "');\n";
			$config .= "define('GALERIE_STYLE', '" . $conf['GALERIE_STYLE'] . "');\n";
			$config .= "define('GALERIE_URL_TYPE', '" . $conf['GALERIE_URL_TYPE'] . "');\n";
			$config .= "define('GALERIE_ALBUMS', '" . $conf['GALERIE_ALBUMS'] . "');\n";
			$config .= "define('GALERIE_INSTALL', 1);\n";
			$config .= "define('GALERIE_VERSION', '" . $conf['GALERIE_VERSION'] . "');\n";
			$config .= "define('GALERIE_INTEGRATED', " . $conf['GALERIE_INTEGRATED'] . ");\n";
			$config .= "\n?>";
			if (!@fwrite($id, $config)) {
				return FALSE;
			}
			@fclose($id);
			return TRUE;
		} else {
			return FALSE;
		}
	}

	/*
	  *	Changements MySQL antrieurs  la version 0.3.
	*/
	function update_champ_poids_cat($mysql) {
		$mysql_error = 0;

		// Changement du type des champs "categorie_poids" et "categorie_poids_inactive" de la table des catgories.
		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'categories CHANGE categorie_poids categorie_poids DECIMAL(12,1) NOT NULL';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}
		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'categories CHANGE categorie_poids_inactive categorie_poids_inactive DECIMAL(12,1) NOT NULL';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		// Rcupration des poids de toutes les catgories situes  la racine.
		$mysql_requete = 'SELECT categorie_poids,categorie_poids_inactive FROM ' . MYSQL_PREF . 'categories
			WHERE categorie_chemin REGEXP "^[^/]+/$"';
		if (!$categorie_poids = $mysql->select($mysql_requete, 1)) {
			$mysql_error = 1;
		}

		// Calcule du poids total.
		$poids_total = 0;
		$poids_inactive_total = 0;
		for ($i = 0; $i < count($categorie_poids['categorie_poids']); $i++) {
			$poids_total += $categorie_poids['categorie_poids'][$i];
			$poids_inactive_total += $categorie_poids['categorie_poids_inactive'][$i];
		}

		// Update du poids total.
		$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'categories SET categorie_poids = "' . $poids_total . '",categorie_poids_inactive = "' . $poids_inactive_total . '" WHERE categorie_id = "1"';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		// Suppression de l'index de la table config et ajout d'une cl primaire sur "parametre".
		$mysql_requete = 'DELETE FROM ' . MYSQL_PREF . 'config WHERE parametre = "galerie_images_window" AND valeur = ""';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}
		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'config DROP INDEX parametre, ADD PRIMARY KEY (parametre)';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration des champs Exif pour la table des images.
	*/
	function create_champs_exif($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'images
			ADD image_exif_datetimeoriginal INT(10) NOT NULL AFTER image_largeur,
			ADD image_exif_make TINYTEXT AFTER image_exif_datetimeoriginal,
			ADD image_exif_model TINYTEXT AFTER image_exif_make';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}
	
	/*
	  *	Change le type du champ image_note de la table des images.
	*/
	function change_image_note_type($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'images CHANGE image_note image_note DECIMAL(6,4)';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration du champs cookie pour la table des votes.
	*/
	function create_champ_vote_cookie($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'votes
			ADD vote_cookie VARCHAR(12) NOT NULL AFTER vote_ip';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration des champs note pour la table des catgories.
	*/
	function create_champ_categorie_note($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'categories
			ADD categorie_note DECIMAL(6,4) NOT NULL AFTER categorie_commentaires_inactive,
			ADD categorie_note_inactive DECIMAL(6,4) NOT NULL AFTER categorie_note';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	 *	Calcul les notes moyennes et notes moyennes inactives de toutes les catgories.
	*/
	function calcul_categorie_note($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'SELECT categorie_id,categorie_chemin FROM ' . MYSQL_PREF . 'categories';
		if (!$categories = $mysql->select($mysql_requete)) {
			return 1;
		}

		for ($i = 0; $i < count($categories); $i++) {

			if ($categories[$i]['categorie_chemin'] == '.') {
				$categories[$i]['categorie_chemin'] = '';
			}

			// Images actives.
			$mysql_requete = 'SELECT SUM(image_note*image_votes)/SUM(image_votes) FROM ' . MYSQL_PREF . 'images
				WHERE image_chemin LIKE "' . $categories[$i]['categorie_chemin'] . '%" 
				  AND image_note > 0
				  AND image_visible = "1"';
			if (($note_active = $mysql->select($mysql_requete, 5)) === false) {
				$mysql_error = 1;
			}

			// Images dsactives.
			$mysql_requete = 'SELECT SUM(image_note*image_votes)/SUM(image_votes) FROM ' . MYSQL_PREF . 'images
				WHERE image_chemin LIKE "' . $categories[$i]['categorie_chemin'] . '%" 
				  AND image_note > 0
				  AND image_visible = "0"';
			if (($note_inactive = $mysql->select($mysql_requete, 5)) === false) {
				$mysql_error = 1;
			}

			if (($note_active && $note_active > 0) || ($note_inactive && $note_inactive > 0)) {
				$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'categories
					SET categorie_note = "' . $note_active . '",
						categorie_note_inactive = "' . $note_inactive . '"
					WHERE categorie_id = "' . $categories[$i]['categorie_id'] . '"';
				if (!$mysql->requete($mysql_requete)) {
					$mysql_error = 1;
				}
			}
		}

		return $mysql_error;
	}

	/*
	 *	Divise par deux la note de toutes les images.
	*/
	function divise_image_note($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'images
			SET image_note = image_note/2 WHERE image_note > 0';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cre un champ 'image_representant_id' dans la table 'categories'.
	*/
	function create_champ_image_representant_id($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'categories
			ADD image_representant_id MEDIUMINT(8) UNSIGNED NOT NULL AFTER categorie_poids_inactive ';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		$mysql_requete = 'SELECT ' . MYSQL_PREF . 'categories.categorie_id,
								 ' . MYSQL_PREF . 'images.image_id
							FROM ' . MYSQL_PREF . 'categories,' . MYSQL_PREF . 'images
						   WHERE ' . MYSQL_PREF . 'categories.categorie_id != "1"
							 AND ' . MYSQL_PREF . 'categories.categorie_representant = ' . MYSQL_PREF . 'images.image_chemin';
		$categories = $mysql->select($mysql_requete);

		if (is_array($categories)) {
			for ($i = 0; $i < count($categories); $i++) {
				$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'categories 
									 SET image_representant_id = "' . $categories[$i]['image_id'] . '"
								   WHERE categorie_id = "' . $categories[$i]['categorie_id'] . '"';
				if (!$mysql->requete($mysql_requete)) {
					$mysql_error = 1;
				}
			}
		}

		return $mysql_error;
	}

	/*
	  *	Cre deux champs 'image_tags' et 'categorie_parent_id' dans la tables 'images'.
	*/
	function create_champs_image_tags_parent_id($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'images
								  ADD categorie_parent_id MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT 0 AFTER image_id,
								  ADD image_tags TEXT AFTER image_description';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		$mysql_requete = 'SELECT categorie_id,
								 categorie_chemin
							FROM ' . MYSQL_PREF . 'categories
						   WHERE categorie_derniere_modif != "0"';
		$albums = $mysql->select($mysql_requete);

		if (is_array($albums)) {
			for ($i = 0; $i < count($albums); $i++) {
				$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'images
									 SET categorie_parent_id = "' . $albums[$i]['categorie_id'] . '"
								   WHERE image_chemin LIKE "' . $albums[$i]['categorie_chemin'] . '%"
								     AND categorie_parent_id = "0"';
				if (!$mysql->requete($mysql_requete)) {
					$mysql_error = 1;
				}
			}
		}

		return $mysql_error;
	}

	/*
	  *	Cre un champ 'image_id' pour la table 'commentaires'.
	*/
	function create_image_id_for_comments($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'commentaires
								  ADD image_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 0 AFTER image_chemin';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'commentaires,
								 ' . MYSQL_PREF . 'images
							 SET ' . MYSQL_PREF . 'commentaires.image_id = ' . MYSQL_PREF . 'images.image_id
						   WHERE ' . MYSQL_PREF . 'commentaires.image_chemin = ' . MYSQL_PREF . 'images.image_chemin';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cre un champ 'image_id' pour la table 'votes'.
	*/
	function create_image_id_for_votes($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'votes
								  ADD image_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 0 AFTER image_chemin';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'votes,
								 ' . MYSQL_PREF . 'images
							 SET ' . MYSQL_PREF . 'votes.image_id = ' . MYSQL_PREF . 'images.image_id
						   WHERE ' . MYSQL_PREF . 'votes.image_chemin = ' . MYSQL_PREF . 'images.image_chemin';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration de la table 'tags'.
	*/
	function create_table_tags($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'CREATE TABLE IF NOT EXISTS ' . MYSQL_PREF . 'tags (
			tag_id VARCHAR(255) NOT NULL,
			image_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 0,
			PRIMARY KEY (tag_id, image_id)) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		$mysql_requete = 'CREATE INDEX idx_image_id on ' . MYSQL_PREF . 'tags(image_id)';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Supprime le prfixe du champ 'categorie_date' de la table 'categories'.
	*/
	function supp_prefixe_categorie_date($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'categories
							 SET categorie_date = categorie_date-10000000000
						   WHERE categorie_date LIKE "1__________"';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'categories
							 SET categorie_date = categorie_date*1
						   WHERE categorie_date LIKE "0__________"';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Ajoutel'attribut BINARY au champ 'tag_id' de la table des tags.
	*/
	function add_tags_binary($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'tags CHANGE tag_id tag_id VARCHAR(255) BINARY NOT NULL';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Chnage et ajoute des paramtres de la table des images.
	*/
	function add_change_table_images($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'images
							      ADD user_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 1 AFTER categorie_parent_id,
							   CHANGE image_nom image_nom TINYTEXT NOT NULL,
							   CHANGE image_date image_date INT(10) NOT NULL DEFAULT 0,
							   CHANGE image_date_creation image_date_creation INT(10) NOT NULL DEFAULT 0,
							   CHANGE image_exif_datetimeoriginal image_exif_datetimeoriginal INT(10) NOT NULL,
							   CHANGE image_note image_note DECIMAL(6,4) UNSIGNED DEFAULT 0,
							   CHANGE image_pass image_pass VARCHAR(40),
							   CHANGE image_visible image_visible ENUM ("0","1") NOT NULL DEFAULT "1"';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Chnage et ajoute des paramtres de la table des categories.
	*/
	function add_change_table_categories($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'categories
							   CHANGE categorie_poids categorie_poids DECIMAL(12,1) UNSIGNED NOT NULL DEFAULT 0,
							   CHANGE categorie_poids_inactive categorie_poids_inactive DECIMAL(12,1) UNSIGNED NOT NULL DEFAULT 0,
							   CHANGE categorie_pass categorie_pass VARCHAR(40),
							   CHANGE categorie_visible categorie_visible ENUM ("0","1") NOT NULL DEFAULT "1"';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Chnage et ajoute des paramtres de la table des commentaires.
	*/
	function add_change_table_commentaires($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'commentaires
							      ADD user_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 0,
							   CHANGE commentaire_visible commentaire_visible ENUM ("0","1","2") NOT NULL DEFAULT "1"';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Chnage et ajoute des paramtres de la table des votes.
	*/
	function add_change_table_votes($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'votes
							   CHANGE vote_note vote_note TINYINT(1) NOT NULL DEFAULT 0';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Chnage et ajoute des paramtres de la table des votes.
	*/
	function add_change_table_tags($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'tags
							   CHANGE tag_id tag_id VARBINARY(255) NOT NULL';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Change les valeurs "" en NULL pour le champ image_pass
	*/
	function change_image_pass_null($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'images
							 SET image_pass = NULL
						   WHERE image_pass = ""';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Change les valeurs "" en NULL pour le champ image_pass
	*/
	function change_categorie_pass_null($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'categories
							 SET categorie_pass = NULL
						   WHERE categorie_pass = ""';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration de la table des membres.
	*/
	function create_table_users($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'CREATE TABLE IF NOT EXISTS ' . MYSQL_PREF . 'users (
			user_id MEDIUMINT UNSIGNED PRIMARY KEY AUTO_INCREMENT,
			groupe_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 3,
			user_login VARCHAR(50) NOT NULL,
			user_pass VARCHAR(32) NOT NULL,
			user_oubli VARCHAR(27),
			user_mail VARCHAR(255),
			user_mail_public ENUM ("0","1") NOT NULL DEFAULT "0",
			user_web TINYTEXT,
			user_lieu VARCHAR(60),
			user_avatar ENUM ("0","1") NOT NULL DEFAULT "0",
			user_newsletter ENUM ("0","1") NOT NULL DEFAULT "0",
			user_date_creation INT(10) NOT NULL DEFAULT 0,
			user_date_derniere_visite INT(10) NOT NULL DEFAULT 0,
			user_ip_creation VARCHAR(20),
			user_ip_derniere_visite VARCHAR(20),
			user_date_dernier_upload INT(10) NOT NULL DEFAULT 0,
			user_session_id VARCHAR(20),
			UNIQUE KEY (user_login)) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration de la table des groupes.
	*/
	function create_table_groupes($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'CREATE TABLE IF NOT EXISTS ' . MYSQL_PREF . 'groupes (
			groupe_id MEDIUMINT UNSIGNED PRIMARY KEY AUTO_INCREMENT,
			groupe_nom VARCHAR(80) NOT NULL,
			groupe_titre VARCHAR(80) NOT NULL,
			groupe_date_creation INT(10) NOT NULL DEFAULT 0,
			groupe_commentaires ENUM ("0","1") NOT NULL DEFAULT "1",
			groupe_votes ENUM ("0","1") NOT NULL DEFAULT "1",
			groupe_recherche_avance ENUM ("0","1") NOT NULL DEFAULT "1",
			groupe_perso ENUM ("0","1") NOT NULL DEFAULT "1",
			groupe_upload ENUM ("0","1") NOT NULL DEFAULT "0",
			groupe_upload_mode ENUM ("direct","attente") NOT NULL DEFAULT "attente",
			groupe_album_pass_mode ENUM ("aucun","tous","select") NOT NULL DEFAULT "aucun",
			groupe_album_pass TEXT NOT NULL,
			groupe_newsletter ENUM ("0","1") NOT NULL DEFAULT "0",
			UNIQUE KEY (groupe_nom)) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration de la table des images en attente.
	*/
	function create_table_images_attente($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'CREATE TABLE IF NOT EXISTS ' . MYSQL_PREF . 'images_attente (
			img_att_id MEDIUMINT UNSIGNED PRIMARY KEY AUTO_INCREMENT,
			user_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 0,
			categorie_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 0,
			img_att_nom TINYTEXT,
			img_att_description TEXT,
			img_att_fichier TINYTEXT NOT NULL,
			img_att_type VARCHAR(4) NOT NULL,
			img_att_poids DECIMAL(8,1) NOT NULL,
			img_att_hauteur VARCHAR(5) NOT NULL,
			img_att_largeur VARCHAR(5) NOT NULL,
			img_att_date INT(10) NOT NULL DEFAULT 0,
			img_att_ip VARCHAR(20)) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration de la table des favoris.
	*/
	function create_table_favoris($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'CREATE TABLE IF NOT EXISTS ' . MYSQL_PREF . 'favoris (
			fav_id MEDIUMINT UNSIGNED PRIMARY KEY AUTO_INCREMENT,
			user_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 0,
			image_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 0) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration des trois premiers groupes.
	*/
	function create_groupes($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'INSERT IGNORE ' . MYSQL_PREF . 'groupes(
			groupe_nom,
			groupe_titre,
			groupe_date_creation,
			groupe_commentaires,
			groupe_votes,
			groupe_recherche_avance,
			groupe_perso,
			groupe_upload,
			groupe_upload_mode,
			groupe_album_pass_mode,
			groupe_newsletter)
			VALUES("admin", "administrateur", "' . time() . '", "1", "1", "1", "1", "0", "direct", "tous", "0"),
				  ("invits", "invit", "' . time() . '", "0", "0", "1", "1", "0", "attente", "aucun", "0"),
				  ("membres", "membre", "' . time() . '", "1", "1", "1", "1", "0", "attente", "aucun", "1")';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Cration de l'utilisateur admin.
	*/
	function create_user_admin($mysql, $admin_courriel) {
		$mysql_error = 0;

		$mysql_requete = 'INSERT IGNORE ' . MYSQL_PREF . 'users(
							groupe_id,
							user_login,
							user_pass,
							user_mail,
							user_date_creation,
							user_date_derniere_visite
							) VALUES (
							"1",
							"' . ADMIN_USER . '",
							"' . md5(ADMIN_PASS) . '",
							"' . outils::protege_mysql($admin_courriel, $mysql->lien) . '",
							"' . time() . '",
							"' . time() . '")';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}
	function update_courriel_admin($mysql, $admin_courriel) {
		$mysql_error = 0;

		if ($admin_courriel) {
			$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'config
								 SET valeur = "' . outils::protege_mysql($admin_courriel, $mysql->lien) . '"
							   WHERE parametre = "admin_mail"';
			if (!$mysql->requete($mysql_requete)) {
				$mysql_error = 1;
			}
		}

		return $mysql_error;
	}

	/*
	  *	Change le champ 'user_mail'.
	*/
	function user_mail_varchar255($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'users
							   CHANGE user_mail user_mail VARCHAR(255)';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Ajoute le champ 'groupe_upload_create'
	*/
	function add_groupe_upload_create($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'groupes
							      ADD groupe_upload_create ENUM ("0","1") NOT NULL DEFAULT "0"';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}

	/*
	  *	Change le champ 'categorie_visible' et
	  *	ajoute le champ 'user'id'  la table des catgories.
	*/
	function change_categorie_visible_user_id($mysql) {
		$mysql_error = 0;

		$mysql_requete = 'ALTER TABLE ' . MYSQL_PREF . 'categories
								  ADD user_id MEDIUMINT UNSIGNED NOT NULL DEFAULT 1,
							   CHANGE categorie_visible categorie_visible ENUM ("0","1","2") NOT NULL DEFAULT "1"';
		if (!$mysql->requete($mysql_requete)) {
			$mysql_error = 1;
		}

		return $mysql_error;
	}


	/* ---------- BASE DE DONNES ---------- */

	// Connexion  la base de donnes.
	$mysql = new connexion(MYSQL_SERV, MYSQL_USER, MYSQL_PASS, MYSQL_BASE);

	// Rcupration des paramtres de configuration.
	$mysql_requete = 'SELECT parametre,valeur FROM ' . MYSQL_PREF . 'config';
	$config = $mysql->select($mysql_requete, 3);
	if (empty($config)) {
		die('La base de donnes est vide.');
	}

	// Vrification de la version.
	$version = mysql_get_server_info();
	$version = preg_replace('`(\d+)(?:\.(\d+))?(?:\.(\d+))?(?:\.(\d+))?`', '$1.$2$3$4', $version);
	$version = floatval($version);
	if ($version < 4.12) {
		$mysql->fermer();
		die('Impossible de mettre  jour la galerie : la version de MySQL doit tre gale ou suprieure  4.1.2');
	}

	if (!defined('ADMIN_USER') && !empty($config['admin_user'])) {
		define('ADMIN_USER', $config['admin_user']);
		define('ADMIN_PASS', $config['admin_pass']);
	}

	$exif_params = 'a:2:{s:4:\"IFD0\";a:7:{s:4:\"Make\";a:3:{s:6:\"active\";i:1;s:4:\"desc\";s:6:\"Marque\";s:6:\"method\";s:6:\"simple\";}s:5:\"Model\";a:3:{s:6:\"active\";i:1;s:4:\"desc\";s:6:\"Modle\";s:6:\"method\";s:6:\"simple\";}s:11:\"XResolution\";a:3:{s:6:\"active\";i:0;s:4:\"desc\";s:22:\"Rsolution horizontale\";s:6:\"method\";s:6:\"simple\";}s:11:\"YResolution\";a:3:{s:6:\"active\";i:0;s:4:\"desc\";s:20:\"Rsolution verticale\";s:6:\"method\";s:6:\"simple\";}s:14:\"ResolutionUnit\";a:4:{s:6:\"active\";i:0;s:4:\"desc\";s:20:\"Units de rsolution\";s:6:\"method\";s:5:\"liste\";s:6:\"format\";a:3:{i:1;s:6:\"pixels\";i:2;s:6:\"pouces\";i:3;s:11:\"centimtres\";}}s:11:\"Orientation\";a:4:{s:6:\"active\";i:0;s:4:\"desc\";s:11:\"Orientation\";s:6:\"method\";s:5:\"liste\";s:6:\"format\";a:8:{i:1;s:13:\"haut - gauche\";i:2;s:13:\"haut - droite\";i:3;s:12:\"bas - droite\";i:4;s:12:\"bas - gauche\";i:5;s:13:\"gauche - haut\";i:6;s:13:\"droite - haut\";i:7;s:12:\"droite - bas\";i:8;s:12:\"gauche - bas\";}}s:8:\"Software\";a:3:{s:6:\"active\";i:0;s:4:\"desc\";s:8:\"Logiciel\";s:6:\"method\";s:6:\"simple\";}}s:4:\"EXIF\";a:11:{s:12:\"ExposureTime\";a:4:{s:6:\"active\";i:1;s:4:\"desc\";s:18:\"Temps d\'exposition\";s:6:\"method\";s:6:\"nombre\";s:6:\"format\";s:7:\"%2.4f s\";}s:16:\"DateTimeOriginal\";a:4:{s:6:\"active\";i:1;s:4:\"desc\";s:32:\"Date et heure de la prise de vue\";s:6:\"method\";s:4:\"date\";s:6:\"format\";s:19:\"%d %B %Y  %H:%M:%S\";}s:11:\"FocalLength\";a:4:{s:6:\"active\";i:1;s:4:\"desc\";s:18:\"Longueur de focale\";s:6:\"method\";s:6:\"nombre\";s:6:\"format\";s:8:\"%2.2f mm\";}s:7:\"FNumber\";a:4:{s:6:\"active\";i:1;s:4:\"desc\";s:9:\"Ouverture\";s:6:\"method\";s:6:\"nombre\";s:6:\"format\";s:4:\"f/%s\";}s:5:\"Flash\";a:4:{s:6:\"active\";i:1;s:4:\"desc\";s:5:\"Flash\";s:6:\"method\";s:5:\"liste\";s:6:\"format\";a:22:{i:0;s:19:\"Flash non dclench\";i:1;s:15:\"Flash dclench\";i:5;s:27:\"Retour de flash non dtect\";i:7;s:23:\"Retour de flash dtect\";i:9;s:27:\"Flash dclench, mode forc\";i:13;s:56:\"Flash dclench, mode forc, retour de flash non dtect\";i:15;s:52:\"Flash dclench, mode forc, retour de flash dtect\";i:16;s:31:\"Flash non dclench, mode forc\";i:24;s:37:\"Flash non dclench, mode automatique\";i:25;s:33:\"Flash dclench, mode automatique\";i:29;s:62:\"Flash dclench, mode automatique, retour de flash non dtect\";i:31;s:58:\"Flash dclench, mode automatique, retour de flash dtect\";i:32;s:19:\"Pas de flash activ\";i:65;s:40:\"Flash dclench, anti yeux-rouges activ\";i:69;s:69:\"Flash dclench, anti yeux-rouges activ, retour de flash non dtect\";i:71;s:65:\"Flash dclench, anti yeux-rouges activ, retour de flash dtect\";i:73;s:52:\"Flash dclench, mode forc, anti yeux-rouges activ\";i:77;s:81:\"Flash dclench, mode forc, anti yeux-rouges activ, retour de flash non dtect\";i:79;s:77:\"Flash dclench, mode forc, anti yeux-rouges activ, retour de flash dtect\";i:93;s:87:\"Flash dclench, mode automatique, anti yeux-rouges activ, retour de flash non dtect\";i:95;s:83:\"Flash dclench, mode automatique, anti yeux-rouges activ, retour de flash dtect\";i:89;s:58:\"Flash dclench, mode automatique, anti yeux-rouges activ\";}}s:11:\"ExifVersion\";a:3:{s:6:\"active\";i:0;s:4:\"desc\";s:12:\"Version Exif\";s:6:\"method\";s:7:\"version\";}s:15:\"ISOSpeedRatings\";a:3:{s:6:\"active\";i:0;s:4:\"desc\";s:3:\"ISO\";s:6:\"method\";s:6:\"simple\";}s:16:\"MaxApertureValue\";a:4:{s:6:\"active\";i:0;s:4:\"desc\";s:18:\"Ouverture maximale\";s:6:\"method\";s:6:\"nombre\";s:6:\"format\";s:8:\"%2.2f mm\";}s:12:\"WhiteBalance\";a:4:{s:6:\"active\";i:0;s:4:\"desc\";s:18:\"Balance des blancs\";s:6:\"method\";s:5:\"liste\";s:6:\"format\";a:2:{i:0;s:11:\"Automatique\";i:1;s:8:\"Manuelle\";}}s:15:\"ExposureProgram\";a:4:{s:6:\"active\";i:0;s:4:\"desc\";s:17:\"Mode d\'exposition\";s:6:\"method\";s:5:\"liste\";s:6:\"format\";a:8:{i:1;s:10:\"Non dfini\";i:2;s:6:\"Manuel\";i:3;s:18:\"Priorit ouverture\";i:4;s:27:\"Priorit temps d\'exposition\";i:5;s:19:\"Programme \'creatif\'\";i:6;s:18:\"Programme \'action\'\";i:7;s:13:\"mode portrait\";i:8;s:12:\"mode paysage\";}}s:13:\"SensingMethod\";a:4:{s:6:\"active\";i:0;s:4:\"desc\";s:7:\"Capteur\";s:6:\"method\";s:5:\"liste\";s:6:\"format\";a:3:{i:1;s:10:\"Non dfini\";i:2;s:13:\"Un processeur\";i:3;s:13:\"2 processeurs\";}}}}';

	// Ajout de nouveaux paramtres de configuration.
	$add_conf_mysql = '';


	//--- v0.2 --- //
	if (!isset($config['galerie_images_resize_max_html'])) {
		$add_conf_mysql .= ',("galerie_images_resize_max_html","650x600")';
	}
	if (!isset($config['galerie_images_resize'])) {
		$add_conf_mysql .= ',("galerie_images_resize","0")';
	}

	//--- v0.3 --- //
	if (!isset($config['comment_antiflood'])) {
		$add_conf_mysql .= ',("comment_antiflood","60")';
	}
	if (!isset($config['active_exif'])) {
		$add_conf_mysql .= ',("active_exif","0")';
	}
	if (!isset($config['galerie_exif_params'])) {
		$add_conf_mysql .= ',("galerie_exif_params","' . $exif_params . '")';
	}
	if (!isset($config['galerie_exif_params_default'])) {
		$add_conf_mysql .= ',("galerie_exif_params_default","' . $exif_params . '")';
	}
	if (!isset($config['admin_comment_msg_display'])) {
		$add_conf_mysql .= ',("admin_comment_msg_display","0")';
	}
	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 0.3) {
		if (update_champ_poids_cat($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}

	//--- v0.4 --- //
	if (!isset($config['active_advsearch'])) {
		$add_conf_mysql .= ',("active_advsearch","0")';
	}
	if (!isset($config['galerie_tb_date_format'])) {
		$add_conf_mysql .= ',("galerie_tb_date_format","%d/%m/%Y")';
	}
	if (!isset($config['galerie_im_date_format'])) {
		$add_conf_mysql .= ',("galerie_im_date_format","%A %d %B %Y")';
	}
	if (!isset($config['galerie_images_text_correction'])) {
		$add_conf_mysql .= ',("galerie_images_text_correction","0")';
	}
	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 0.4) {

		// On UPDATE les valeurs par dfaut des paramtres Exif  cause du changement du format de la date.
		$mysql_requete = 'UPDATE ' . MYSQL_PREF . 'config SET valeur="' . $exif_params . '" WHERE parametre="galerie_exif_params_default"';
		if (!$mysql->requete($mysql_requete)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}

		if (create_champs_exif($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}

	//--- v0.4.1 --- //
	if (!isset($config['active_historique'])) {
		$add_conf_mysql .= ',("active_historique","0")';
	}
	if (!isset($config['galerie_contact_method'])) {
		$add_conf_mysql .= ',("galerie_contact_method","antispam")';
	}
	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 0.41) {
		if (change_image_note_type($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}

	//--- v0.5 --- //
	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 0.5) {
		if (create_champ_vote_cookie($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (divise_image_note($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (create_champ_categorie_note($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (calcul_categorie_note($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}
	if (!isset($config['active_diaporama'])) {
		$add_conf_mysql .= ',("active_diaporama","0")';
	}

	//--- v0.6 --- //
	if (!isset($config['vignettes_cat_col'])) {
		$add_conf_mysql .= ',("vignettes_cat_col","4")';
	}
	if (!isset($config['vignettes_cat_line'])) {
		$add_conf_mysql .= ',("vignettes_cat_line","3")';
	}
	if (!isset($config['vignettes_cat_mode'])) {
		$add_conf_mysql .= ',("vignettes_cat_mode","compact")';
	}
	if (!isset($config['display_cat_comments'])) {
		$display_cat_comments = (isset($config['display_comments'])) ? $config['display_comments'] : 0;
		$add_conf_mysql .= ',("display_cat_comments","' . $display_cat_comments . '")';
	}
	if (!isset($config['display_cat_hits'])) {
		$display_cat_hits = (isset($config['display_hits'])) ? $config['display_hits'] : 0;
		$add_conf_mysql .= ',("display_cat_hits","' . $display_cat_hits . '")';
	}
	if (!isset($config['display_cat_nb_images'])) {
		$display_cat_nb_images = (isset($config['display_nb_images'])) ? $config['display_nb_images'] : 1;
		$add_conf_mysql .= ',("display_cat_nb_images","' . $display_cat_nb_images . '")';
	}
	if (!isset($config['display_cat_nom'])) {
		$display_cat_nom = (isset($config['display_nom_categories'])) ? $config['display_nom_categories'] : 1;
		$add_conf_mysql .= ',("display_cat_nom","' . $display_cat_nom . '")';
	}
	if (!isset($config['display_cat_poids'])) {
		$display_cat_poids = (isset($config['display_poids'])) ? $config['display_poids'] : 0;
		$add_conf_mysql .= ',("display_cat_poids","' . $display_cat_poids . '")';
	}
	if (!isset($config['display_cat_votes'])) {
		$display_cat_votes = (isset($config['display_votes'])) ? $config['display_votes'] : 0;
		$add_conf_mysql .= ',("display_cat_votes","' . $display_cat_votes . '")';
	}
	if (!isset($config['display_img_comments'])) {
		$display_img_comments = (isset($config['display_comments'])) ? $config['display_comments'] : 0;
		$add_conf_mysql .= ',("display_img_comments","' . $display_img_comments . '")';
	}
	if (!isset($config['display_img_date'])) {
		$display_img_date = (isset($config['display_date'])) ? $config['display_date'] : 0;
		$add_conf_mysql .= ',("display_img_date","' . $display_img_date . '")';
	}
	if (!isset($config['display_img_hits'])) {
		$display_img_hits = (isset($config['display_hits'])) ? $config['display_hits'] : 0;
		$add_conf_mysql .= ',("display_img_hits","' . $display_img_hits . '")';
	}
	if (!isset($config['display_img_nom'])) {
		$display_img_nom = (isset($config['display_nom_images'])) ? $config['display_nom_images'] : 0;
		$add_conf_mysql .= ',("display_img_nom","' . $display_img_nom . '")';
	}
	if (!isset($config['display_img_poids'])) {
		$display_img_poids = (isset($config['display_poids'])) ? $config['display_poids'] : 0;
		$add_conf_mysql .= ',("display_img_poids","' . $display_img_poids . '")';
	}
	if (!isset($config['display_img_taille'])) {
		$display_img_taille = (isset($config['display_taille'])) ? $config['display_taille'] : 0;
		$add_conf_mysql .= ',("display_img_taille","' . $display_img_taille . '")';
	}
	if (!isset($config['display_img_votes'])) {
		$display_img_votes = (isset($config['display_votes'])) ? $config['display_votes'] : 0;
		$add_conf_mysql .= ',("display_img_votes","' . $display_img_votes . '")';
	}

	//--- v0.7 : nouveaux paramtres de config --- //
	if (!isset($config['admin_vote_nb'])) {
		$add_conf_mysql .= ',("admin_vote_nb","20")';
	}
	if (!isset($config['admin_vote_ordre'])) {
		$add_conf_mysql .= ',("admin_vote_ordre","vote_date")';
	}
	if (!isset($config['admin_vote_sens'])) {
		$add_conf_mysql .= ',("admin_vote_sens","DESC")';
	}
	if (!isset($config['active_liens'])) {
		$add_conf_mysql .= ',("active_liens","0")';
	}
	if (!isset($config['galerie_page_comments'])) {
		$add_conf_mysql .= ',("galerie_page_comments","1")';
	}
	if (!isset($config['galerie_page_comments_nb'])) {
		$add_conf_mysql .= ',("galerie_page_comments_nb","20")';
	}
	if (!isset($config['active_rss'])) {
		$add_conf_mysql .= ',("active_rss","1")';
	}
	if (!isset($config['active_tags'])) {
		$add_conf_mysql .= ',("active_tags","0")';
	}
	if (!isset($config['galerie_nb_tags'])) {
		$add_conf_mysql .= ',("galerie_nb_tags","20")';
	}
	if (!isset($config['galerie_nb_rss'])) {
		$add_conf_mysql .= ',("galerie_nb_rss","20")';
	}
	if (!isset($config['galerie_liens'])) {
		$add_conf_mysql .= ',("galerie_liens","a:1:{i:0;s:33:\"iGalerie:http://www.igalerie.org/\";}")';
	}
	if (!isset($config['galerie_diaporama_resize'])) {
		$add_conf_mysql .= ',("galerie_diaporama_resize","0")';
	}
	if (!isset($config['galerie_add_style'])) {
		$add_conf_mysql .= ',("galerie_add_style","")';
	}

	//--- v0.7 : nouveaux champs --- //
	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 0.7) {
		if (create_champ_image_representant_id($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (create_champs_image_tags_parent_id($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (create_image_id_for_comments($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (create_image_id_for_votes($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}

	//--- v0.7 : nouvelle table --- //
	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 0.7) {
		if (create_table_tags($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}

	//--- v0.7.2 --- //
	if (!isset($config['vignettes_cat_type'])) {
		$add_conf_mysql .= ',("vignettes_cat_type","")';
	}

	//--- v0.7.3 --- //
	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 0.73) {
		if (supp_prefixe_categorie_date($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}

	//--- v0.8 --- //
	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 0.8) {
		if (add_tags_binary($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}
	if (!isset($config['comment_nourl'])) {
		$add_conf_mysql .= ',("comment_nourl","0")';
	}
	if (!isset($config['comment_samemsg'])) {
		$add_conf_mysql .= ',("comment_samemsg","1")';
	}
	if (!isset($config['comment_maxmsg'])) {
		$add_conf_mysql .= ',("comment_maxmsg","1")';
	}
	if (!isset($config['comment_maxmsg_nb'])) {
		$add_conf_mysql .= ',("comment_maxmsg_nb","15")';
	}
	if (!isset($config['admin_no_hits'])) {
		$add_conf_mysql .= ',("admin_no_hits","0")';
	}
	if (!isset($config['admin_no_hits_mode'])) {
		$add_conf_mysql .= ',("admin_no_hits_mode","cookie")';
	}
	if (!isset($config['admin_no_hits_ip'])) {
		$add_conf_mysql .= ',("admin_no_hits_ip","")';
	}
	if (!isset($config['galerie_meta_desc'])) {
		$add_conf_mysql .= ',("galerie_meta_desc","1")';
	}
	if (!isset($config['galerie_meta_desc_txt'])) {
		$add_conf_mysql .= ',("galerie_meta_desc_txt","")';
	}
	if (!isset($config['galerie_message_fermeture'])) {
		$add_conf_mysql .= ',("galerie_message_fermeture","La galerie est ferme.\nVeuillez revenir plus tard.")';
	}

	//--- v1.0b --- //
	if (!isset($config['galerie_titre_court'])) {
		$add_conf_mysql .= ',("galerie_titre_court","iGalerie")';
	}
	if (!isset($config['active_exif_ajout'])) {
		$add_conf_mysql .= ',("active_exif_ajout","1")';
	}
	if (!isset($config['admin_vid'])) {
		$add_conf_mysql .= ',("admin_vid","")';
	}

	// Membres.
	if (!isset($config['users_membres_active'])) {
		$add_conf_mysql .= ',("users_membres_active","0")';
	}
	if (!isset($config['users_membres_alert'])) {
		$add_conf_mysql .= ',("users_membres_alert","1")';
	}
	if (!isset($config['users_membres_avatars'])) {
		$add_conf_mysql .= ',("users_membres_avatars","1")';
	}
	if (!isset($config['users_upload_alert'])) {
		$add_conf_mysql .= ',("users_upload_alert","1")';
	}
	if (!isset($config['admin_membres_nb'])) {
		$add_conf_mysql .= ',("admin_membres_nb","20")';
	}
	if (!isset($config['admin_membres_ordre'])) {
		$add_conf_mysql .= ',("admin_membres_ordre","date_creation")';
	}
	if (!isset($config['admin_membres_sens'])) {
		$add_conf_mysql .= ',("admin_membres_sens","DESC")';
	}
	if (!isset($config['admin_imgatt_nb'])) {
		$add_conf_mysql .= ',("admin_imgatt_nb","20")';
	}
	if (!isset($config['admin_imgatt_ordre'])) {
		$add_conf_mysql .= ',("admin_imgatt_ordre","date_envoi")';
	}
	if (!isset($config['admin_imgatt_sens'])) {
		$add_conf_mysql .= ',("admin_imgatt_sens","DESC")';
	}

	// IPTC.
	$iptc = 'a:32:{s:5:\"2#005\";a:2:{s:3:\"nom\";s:14:\"Nom de l\'objet\";s:6:\"active\";i:0;}s:5:\"2#007\";a:2:{s:3:\"nom\";s:16:\"Statut ditorial\";s:6:\"active\";i:0;}s:5:\"2#010\";a:2:{s:3:\"nom\";s:8:\"Priorit\";s:6:\"active\";i:0;}s:5:\"2#015\";a:2:{s:3:\"nom\";s:9:\"Catgorie\";s:6:\"active\";i:0;}s:5:\"2#020\";a:2:{s:3:\"nom\";s:14:\"Identificateur\";s:6:\"active\";i:0;}s:5:\"2#025\";a:2:{s:3:\"nom\";s:9:\"Mots-cls\";s:6:\"active\";i:1;}s:5:\"2#026\";a:2:{s:3:\"nom\";s:32:\"Code de l\'emplacement du contenu\";s:6:\"active\";i:0;}s:5:\"2#027\";a:2:{s:3:\"nom\";s:31:\"Nom de l\'emplacement du contenu\";s:6:\"active\";i:0;}s:5:\"2#030\";a:2:{s:3:\"nom\";s:14:\"Date de sortie\";s:6:\"active\";i:0;}s:5:\"2#035\";a:2:{s:3:\"nom\";s:15:\"Heure de sortie\";s:6:\"active\";i:0;}s:5:\"2#040\";a:2:{s:3:\"nom\";s:22:\"Instructions spciales\";s:6:\"active\";i:0;}s:5:\"2#055\";a:2:{s:3:\"nom\";s:16:\"Date de cration\";s:6:\"active\";i:1;}s:5:\"2#060\";a:2:{s:3:\"nom\";s:17:\"Heure de cration\";s:6:\"active\";i:0;}s:5:\"2#065\";a:2:{s:3:\"nom\";s:9:\"Programme\";s:6:\"active\";i:0;}s:5:\"2#070\";a:2:{s:3:\"nom\";s:20:\"Version du programme\";s:6:\"active\";i:0;}s:5:\"2#075\";a:2:{s:3:\"nom\";s:16:\"Cycle de l\'objet\";s:6:\"active\";i:0;}s:5:\"2#080\";a:2:{s:3:\"nom\";s:6:\"Auteur\";s:6:\"active\";i:1;}s:5:\"2#085\";a:2:{s:3:\"nom\";s:17:\"Titre de l\'auteur\";s:6:\"active\";i:0;}s:5:\"2#090\";a:2:{s:3:\"nom\";s:5:\"Ville\";s:6:\"active\";i:1;}s:5:\"2#092\";a:2:{s:3:\"nom\";s:6:\"Rgion\";s:6:\"active\";i:0;}s:5:\"2#095\";a:2:{s:3:\"nom\";s:13:\"Province/tat\";s:6:\"active\";i:0;}s:5:\"2#100\";a:2:{s:3:\"nom\";s:9:\"Code pays\";s:6:\"active\";i:0;}s:5:\"2#101\";a:2:{s:3:\"nom\";s:4:\"Pays\";s:6:\"active\";i:0;}s:5:\"2#103\";a:2:{s:3:\"nom\";s:28:\"Rfrence de la transmission\";s:6:\"active\";i:0;}s:5:\"2#105\";a:2:{s:3:\"nom\";s:5:\"Titre\";s:6:\"active\";i:1;}s:5:\"2#110\";a:2:{s:3:\"nom\";s:6:\"Crdit\";s:6:\"active\";i:1;}s:5:\"2#115\";a:2:{s:3:\"nom\";s:6:\"Source\";s:6:\"active\";i:1;}s:5:\"2#116\";a:2:{s:3:\"nom\";s:9:\"Copyright\";s:6:\"active\";i:1;}s:5:\"2#118\";a:2:{s:3:\"nom\";s:7:\"Contact\";s:6:\"active\";i:1;}s:5:\"2#120\";a:2:{s:3:\"nom\";s:11:\"Description\";s:6:\"active\";i:1;}s:5:\"2#122\";a:2:{s:3:\"nom\";s:24:\"Auteur de la description\";s:6:\"active\";i:0;}s:5:\"2#130\";a:2:{s:3:\"nom\";s:15:\"Type de l\'image\";s:6:\"active\";i:0;}}';
	if (!isset($config['galerie_iptc_params'])) {
		$add_conf_mysql .= ',("galerie_iptc_params","' . $iptc . '")';
	}
	if (!isset($config['galerie_iptc_params_default'])) {
		$add_conf_mysql .= ',("galerie_iptc_params_default","' . $iptc . '")';
	}
	if (!isset($config['active_iptc'])) {
		$add_conf_mysql .= ',("active_iptc","0")';
	}
	if (!isset($config['active_iptc_ajout'])) {
		$add_conf_mysql .= ',("active_iptc_ajout","1")';
	}

	// Page contact : un seul mode dsormais.
	if (!isset($config['galerie_contact'])) {
		$contact_active = (empty($config['galerie_contact_courriel'])) ? 0 : 1;
		$add_conf_mysql .= ',("galerie_contact","' . $contact_active . '")';
	}

	// Courriel admin.
	$admin_courriel = '';
	if (!empty($config['galerie_contact_courriel'])) {
		$admin_courriel = $config['galerie_contact_courriel'];
	} elseif (!empty($config['admin_comment_mail'])) {
		$admin_courriel = $config['admin_comment_mail'];
	}
	if (!isset($config['admin_mail'])) {
		$add_conf_mysql .= ',("admin_mail","' . $admin_courriel . '")';
	}

	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 1) {

		// ADD et CHANGE pour quelques tables.
		if (add_change_table_images($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (add_change_table_categories($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (add_change_table_commentaires($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (add_change_table_votes($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (add_change_table_tags($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}

		// Change les champs image_pass et categorie_pass en NULL si "".
		if (change_image_pass_null($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (change_categorie_pass_null($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}

		// Cration des nouvelles tables.
		if (create_table_users($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (create_table_groupes($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (create_table_images_attente($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (create_table_favoris($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		
		// Cration des trois premiers groupes.
		if (create_groupes($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		
		// Cration de l'utilisateur admin.
		if (create_user_admin($mysql, $admin_courriel)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (update_courriel_admin($mysql, $admin_courriel)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}

	//--- v1.0 beta 2 --- //
	if (!defined('GALERIE_VERSION') || floatval(GALERIE_VERSION) < 20071001) {
		if (user_mail_varchar255($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (add_groupe_upload_create($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
		if (change_categorie_visible_user_id($mysql)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}

	// Limites en upload.
	if (!isset($config['users_upload_maxsize'])) {
		$add_conf_mysql .= ',("users_upload_maxsize","500")';
	}
	if (!isset($config['users_upload_maxwidth'])) {
		$add_conf_mysql .= ',("users_upload_maxwidth","3500")';
	}
	if (!isset($config['users_upload_maxheight'])) {
		$add_conf_mysql .= ',("users_upload_maxheight","3500")';
	}

	//--- v1.0.2 --- //
	if (!isset($config['comment_maxurl'])) {
		$add_conf_mysql .= ',("comment_maxurl","2")';
	}




	// On effectue les mises  jour.
	if ($add_conf_mysql) {
		$mysql_requete = 'INSERT ' . MYSQL_PREF . 'config(parametre,valeur) VALUES' . substr($add_conf_mysql, 1);
		if (!$mysql->requete($mysql_requete)) {
			$maj_ok = 0;
			$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
		}
	}


	// On n'a plus besoin de la bdd.
	$mysql->fermer();



	/* ---------- FICHIER DE CONFIG ---------- */

	$conf = array();
	$conf['MYSQL_SERV'] = MYSQL_SERV;
	$conf['MYSQL_USER'] = MYSQL_USER;
	$conf['MYSQL_PASS'] = MYSQL_PASS;
	$conf['MYSQL_BASE'] = MYSQL_BASE;
	$conf['MYSQL_PREF'] = MYSQL_PREF;


	//--- v0.1.1 --- //
	$conf['ADMIN_USER'] = (isset($config['admin_user']) && !defined('ADMIN_USER')) ? $config['admin_user'] : ADMIN_USER;
	$conf['ADMIN_PASS'] = (isset($config['admin_pass']) && !defined('ADMIN_PASS')) ? $config['admin_pass'] : ADMIN_PASS;
	$conf['THUMB_TDIR'] = (isset($config['galerie_repertoire_vignettes']) && !defined('THUMB_TDIR')) ? $config['galerie_repertoire_vignettes'] : THUMB_TDIR;

	$conf['THUMB_PREF'] = (isset($config['galerie_prefixe_vignettes']) && !defined('THUMB_PREF')) ? $config['galerie_prefixe_vignettes'] : THUMB_PREF;
	$conf['GALERIE_ALBUMS'] = (isset($config['galerie_albums_dir']) && !defined('GALERIE_ALBUMS')) ? $config['galerie_albums_dir'] : GALERIE_ALBUMS;

	// --- v0.2 --- //
	$conf['IMG_RESIZE_GD'] = (defined('IMG_RESIZE_GD')) ? IMG_RESIZE_GD : '650x600';
	$conf['GALERIE_THEME'] = (isset($config['galerie_template']) && !defined('GALERIE_THEME')) ? $config['galerie_template'] : GALERIE_THEME;
	$conf['GALERIE_STYLE'] = (isset($config['galerie_style']) && !defined('GALERIE_STYLE')) ? $config['galerie_style'] : GALERIE_STYLE;

	// --- v0.3 --- //
	$conf['IMG_TEXTE'] = (defined('IMG_TEXTE')) ? IMG_TEXTE : 0;
	$conf['IMG_TEXTE_PARAMS'] = (defined('IMG_TEXTE_PARAMS')) ? IMG_TEXTE_PARAMS : 'copyright 0 0 0 Veranda.ttf bottom_center 1 255 255 255 50 1 0 2 149 149 149 10 5 6 1 0 0 48 75 98 0 90';

	// --- v0.6 --- //
	$conf['THUMB_ALB_MODE'] = (defined('THUMB_ALB_MODE')) ? THUMB_ALB_MODE : 'size';
	$conf['THUMB_ALB_SIZE'] = (defined('THUMB_ALB_SIZE')) ? THUMB_ALB_SIZE : 135;
	$conf['THUMB_ALB_CROP_WIDTH'] = (defined('THUMB_ALB_CROP_WIDTH')) ? THUMB_ALB_CROP_WIDTH : 200;
	$conf['THUMB_ALB_CROP_HEIGHT'] = (defined('THUMB_ALB_CROP_HEIGHT')) ? THUMB_ALB_CROP_HEIGHT : 150;
	$conf['THUMB_IMG_MODE'] = (defined('THUMB_IMG_MODE')) ? THUMB_IMG_MODE : 'size';
	$conf['THUMB_IMG_SIZE'] = (defined('THUMB_IMG_SIZE')) ? THUMB_IMG_SIZE : 135;
	$conf['THUMB_IMG_CROP_WIDTH'] = (defined('THUMB_IMG_CROP_WIDTH')) ? THUMB_IMG_CROP_WIDTH : 85;
	$conf['THUMB_IMG_CROP_HEIGHT'] = (defined('THUMB_IMG_CROP_HEIGHT')) ? THUMB_IMG_CROP_HEIGHT : 85;
	$conf['THUMB_QUALITY'] = (defined('THUMB_QUALITY')) ? THUMB_QUALITY : 80;

	// --- v0.7 --- //
	$conf['GALERIE_URL_TYPE'] = (defined('GALERIE_URL_TYPE')) ? GALERIE_URL_TYPE : 'normal';

	$galerie_path = dirname($_SERVER['SCRIPT_NAME']);
	$galerie_path = (preg_match('`^[./]*$`', $galerie_path)) ? '' : $galerie_path;
	$galerie_path = preg_replace('`/+$`', '', $galerie_path);
	$galerie_path = preg_replace('[\x5c]', '', $galerie_path);
	$conf['GALERIE_URL'] = (defined('GALERIE_URL')) ? GALERIE_URL : $galerie_path . '/index.php';
	$conf['GALERIE_PATH'] = (defined('GALERIE_PATH')) ? GALERIE_PATH : $galerie_path;

	// --- v0.7.1 --- //
	$conf['GALERIE_INTEGRATED'] = (defined('GALERIE_INTEGRATED')) ? GALERIE_INTEGRATED : 0;

	// On effectue les mises  jour.
	$conf['GALERIE_VERSION'] = '20130107';
	if (!upgrade_conf($conf)) {
		$maj_ok = 0;
		$error_code .= __LINE__ . ' [' . mysql_error() . '];<br />';
	}



	/* ---------- DIVERS ---------- */

	// --- v1.0.6 --- //
	$file = './cache/.htaccess';
	if (file_exists($file) && !files::suppFile($file)) {
		$maj_ok = 0;
		$error_code .= __LINE__ . ' [Pour que la mise  jour soit complte, vous devez supprimer le fichier "cache/.htaccess"];<br />';
	}
}

define('CHARSET', 'ISO-8859-15');
header('Content-Type: text/html; charset=' . CHARSET);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">



<head>

<title>mise  jour - iGalerie</title>

<style type="text/css">
html {
	font-family: Verdana, sans-serif;
	font-size: .8em;
	border: 0; 
}
body,img,form,h1,p {
	border: 0;
	padding: 0;
	margin: 0;
}
body {
	padding: 30px 0 20px;
}
#global {
	width: 400px;
	margin: 0 auto;
	text-align: left;
	border: 1px solid #99B15F;
}
#titre {
	height: 60px;
	background: url(admin/template/defaut/style/fond_haut.png) repeat-x 0 100%;
}
a {
	color: black;
}
a:hover {
	color: #D58B0B;
	text-decoration: none;
}
h1 {
	font-size: 2em;
	color: #5F6E38;
	letter-spacing: -.05em;
	padding: 8px;
	top: 12px;
	position: relative;
}
#contenu {
	padding: 15px;
}
#bouton_maj {
	margin-top: 20px;
	padding: 3px 12px;
	font-weight: bold;
}
#instruction strong {
	font-family: "Georgia", serif;
	font-size: 130%;
	font-style: italic;
}
#maj_echec {
	font-weight: bold;
	color: red;
	background: url(admin/template/defaut/style/erreur.png) no-repeat 0 1px;
	padding: 3px 0 3px 26px;
}
#maj_ok {
	font-weight: bold;
	color: #648F27;
	background: url(admin/template/defaut/style/succes.png) no-repeat 0 1px;
	padding: 3px 0 3px 26px;
}
#maj_info {
	font-weight: bold;
	color: #1B6FCD;
	background: url(admin/template/defaut/style/information.png) no-repeat 0 1px;
	padding: 3px 0 3px 26px;
}
</style>

</head>


<body>

<div id="global">

	<div id="titre">
		<h1>Mise  jour</h1>
	</div>

	<div id="contenu">
		<?php if (empty($_POST['upgrade'])) : ?>
		<p id="instruction">Cliquez sur ce bouton pour mettre  jour <strong><a href="http://www.igalerie.org/">iGalerie</a></strong><br/>vers la version 1.0.7.</p>
		<br/>
		<form action="" method="post">
			<div><input name="upgrade" id="bouton_maj" value="Mettre  jour iGalerie" type="submit" /></div>
		</form>
		<?php elseif ($maj_ok) : ?>
		<p id="maj_ok">Mise  jour effectue avec succs !</p>
		<br/>
		<p id="maj_info">N'oubliez pas de supprimer le fichier <?php echo outils::htmlentities_latin1(basename($_SERVER['PHP_SELF'])); ?> avant de poursuivre.</p>
		<?php else : ?>
		<p id="maj_echec">chec de la mise  jour.<br/>Code d'erreur : <?php echo $error_code; ?></p>
		<?php endif; ?>
	</div>
	
</div>

</body>


</html>
